Con                                                         
                                                         
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000

   _leftFW = 24   
   _leftBW = 25   
   _rightFW = 26  
   _rightBW = 27
    
   '_timeStepInMilliseconds = 10     
   _updateFrequencyInHertz = 8_000
    
   RAMPING = 5  '*100us delay per step duty cycle
   
Var

  long left_old, right_old
  
Obj
  
  hbd : "pwm2c_hbdengine"
  
Pub Main
  
  hbd.hbdenginestart(_leftFW, _leftBW, _rightFW, _rightBW, _updateFrequencyInHertz)  'start pwm
    '
  Wheels(-500, 500)    'forward @ half speed
  
  waitcnt(clkfreq+cnt) 'pause before setting wheels again
      
  Wheels(500, -500)    'reverse @ half speed

  waitcnt(clkfreq+cnt) 'pause before setting wheels again  

  Wheels(500, 500)     'turn left @ half speed

  waitcnt(clkfreq+cnt) 'pause before setting wheels again

  Wheels(-500, -500)   'turn right @ half speed

  waitcnt(clkfreq+cnt) 'pause before setting wheels again

  Wheels(0, 0)         'stop
  
Pub Wheels(left, right) 
   
  repeat
  
    if left < left_old                       'increment or decrement by one to new speed'
      hbd.leftduty(--left_old)
      
    if left > left_old
      hbd.leftduty(++left_old)
      
    if right < right_old  
      hbd.rightduty(--right_old)
      
    if right > right_old
      hbd.rightduty(++right_old)
       
    if left_old == left                      'check if both left and right wheels-
      if right_old == right                  '-are @ new speeds and return from-
        left_old := left                     '-this method when met
        right_old := right       
        return
  
    waitcnt(clkfreq / 10000 * RAMPING + cnt) 'RAMPING * 100us pause per step duty cycle   